#include <cvtfname.h>
#include <strtok.h>
#include <templtok.h>
#include <string.h>

DWORD FileNameToMP3TagZ(
     LPCTSTR lpcszFileName,
     LPCTSTR lpcszTemplate,
     tMP3tagZ *lpTagZ )
{
     DWORD dwResult = 0;
     TCHAR Token;
     DWORD dwType;
     tStringToken StringToken( lpcszFileName );
     tTemplateToken TemplToken( lpcszTemplate );
     TCHAR *Buffer;
     TCHAR *lpMP3TagZField;
     DWORD dwMP3TagZFieldSize;

     /*
     ZeroTagZ( lpTagZ );
     ZeroMemory(
          lpTagZ,
          sizeof( *lpTagZ ) -
               sizeof( lpTagZ -> exist ) -
               sizeof( lpTagZ -> findData )
     );
     */
     Buffer = new TCHAR[strlen( lpcszFileName ) + 1];
     do
     {
          dwType = TemplToken. Get( &Token );
          if ( dwType == TOKEN_SYMBOL )
          {
               if ( Token != StringToken. Get() )
               {
                    break;
               }
          }
          else if ( dwType == TOKEN_EOL )
          {
               if ( StringToken. Get() == 0 )
               {
                    dwResult = EOF;
               }
               break;
          }
          else if ( dwType == TOKEN_TEMPLATE )
          {
               if ( !MacroToMP3TagZField(
                    Token,
                    lpTagZ,
                    &lpMP3TagZField,
                    &dwMP3TagZFieldSize ) )
               {
                    dwType = TOKEN_ERROR;
                    break;
               }
               dwType = TemplToken. Get( &Token );
               TemplToken. PutBack();
               if ( dwType == TOKEN_EOL )
               {
                    StringToken. Get( Buffer );
               }
               else if ( dwType == TOKEN_SYMBOL )
               {
                    StringToken. Get( Buffer, Token );
               }
               else
               {
                    break;
               }
               if ( lpMP3TagZField != NULL )
               {
                    strncpy( lpMP3TagZField, Buffer, dwMP3TagZFieldSize - 1 );
                    dwResult++;
               }
          }
     }
     while ( dwType != TOKEN_ERROR );
     delete[] Buffer;

     return dwResult;
}

BOOL MP3TagZToFileName(
	LPTSTR lpszFileName,
	LPCTSTR lpcszTemplate,
     const tMP3tagZ *lpTagZ )
{
     BOOL bResult = FALSE;
     TCHAR Token;
     DWORD dwType;
     tTemplateToken TemplToken( lpcszTemplate );
     DWORD dwIndex = 0;
     TCHAR *lpMP3TagZField;
     DWORD dwMP3TagZFieldSize;

     do
     {
          dwType = TemplToken. Get( &Token );
          if ( dwType == TOKEN_SYMBOL )
          {
               lpszFileName[dwIndex] = Token;
               dwIndex++;
          }
          else if ( dwType == TOKEN_EOL )
          {
               lpszFileName[dwIndex] = 0;
               bResult = TRUE;
               break;
          }
          else if ( dwType == TOKEN_TEMPLATE )
          {
               if ( !MacroToMP3TagZField(
                    Token,
                    lpTagZ,
                    &lpMP3TagZField,
                    &dwMP3TagZFieldSize ) )
               {
                    break;
               }
               if ( lpMP3TagZField == NULL )
               {
                    continue;
               }
               strncpy( lpszFileName + dwIndex, lpMP3TagZField, dwMP3TagZFieldSize );
               dwIndex = strlen( lpszFileName );
          }
     }
     while ( dwType != TOKEN_ERROR );

     return bResult;
}

BOOL MacroToMP3TagZField(
	TCHAR Macros,
	const tMP3tagZ *lpTagZ,
	LPTSTR *lplpszField,
	LPDWORD lpdwFieldSize )
{
     BOOL bResult = TRUE;

     switch ( Macros )
     {
          case 't':
          case 'T':
			   *lplpszField = ( LPTSTR ) lpTagZ -> title;
			   *lpdwFieldSize = sizeof( lpTagZ -> title );
               break;
          case 'a':
          case 'A':
                  *lplpszField = ( LPTSTR ) lpTagZ -> artist;
                  *lpdwFieldSize = sizeof( lpTagZ -> artist );
               break;
          case 'b':
          case 'B':
			   *lplpszField = ( LPTSTR ) lpTagZ -> album;
			   *lpdwFieldSize = sizeof( lpTagZ -> album );
               break;
          case 'y':
          case 'Y':
			   *lplpszField = ( LPTSTR ) lpTagZ -> year;
			   *lpdwFieldSize = sizeof( lpTagZ -> year );
               break;
          case 'c':
          case 'C':
			   *lplpszField = ( LPTSTR ) lpTagZ -> comment;
			   *lpdwFieldSize = sizeof( lpTagZ -> comment );
               break;
          case 'u':
          case 'U':
			   *lplpszField = NULL;
               break;
          default:;
			   bResult = FALSE;
     }

     return bResult;
}
