#include <desc.h>
#include <string.h>

BOOL ReadLine(
     HANDLE hFile,
     TCHAR lpBuffer[],
     DWORD dwBuffer )
{
     BOOL bResult = FALSE;
     TCHAR __ca[2];
     DWORD dwRead;

     for ( DWORD idx = 0; idx < dwBuffer; idx++ )
     {
          if ( !ReadFile(
                    hFile,
                    &__ca[0],
                    sizeof( __ca[0] ),
                    &dwRead,
                    NULL ) ||
               !dwRead )
          {
               break;
          }
          if ( __ca[0] == 0x0d )
          {
               if ( !ReadFile(
                         hFile,
                         &__ca[1],
                         sizeof( __ca[1] ),
                         &dwRead,
                         NULL ) ||
                    !dwRead )
               {
                    break;
               }
               if ( __ca[1] == 0x0a )
               {
                    bResult = TRUE;
                    break;
               }
               else
               {
                    lpBuffer[idx] = __ca[0];
                    SetFilePointer(
                         hFile,
                         -1,
                         NULL,
                         FILE_CURRENT
                    );
               }
          }
          else
          {
               lpBuffer[idx] = __ca[0];
          }
     }
     lpBuffer[idx] = 0;

     return bResult;
}

BOOL SplitFileDesc(
     LPCTSTR lpcszSrc,
     LPTSTR lpszFileName,
     LPTSTR lpszDesc )
{
     BOOL bResult = FALSE;
     BOOL bSpaces;
     DWORD idx, __idx;

     if ( lpcszSrc[0] == '\"' )
     {
          bSpaces = TRUE;
          idx = 1;
     }
     else
     {
          bSpaces = FALSE;
          idx = 0;
     }
     for ( __idx = 0; lpcszSrc[idx]; idx++, __idx++ )
     {
          if ( ( bSpaces && lpcszSrc[idx] == '\"' ) ||
               ( !bSpaces && lpcszSrc[idx] == ' ' ) )
          {
               lpszFileName[__idx] = 0;
               bResult = TRUE;
               idx++;
               break;
          }
          lpszFileName[__idx] = lpcszSrc[idx];
     }
     for ( ; lpcszSrc[idx] == ' '; idx++ );
     for ( __idx = 0; lpcszSrc[idx]; idx++, __idx++ )
     {
          lpszDesc[__idx] = lpcszSrc[idx];
     }
     lpszDesc[__idx] = 0;

     return bResult;
}

BOOL LoadDescFile(
     LPCTSTR lpcszFileName,
     DESC lpDesc[],
     DWORD dwDesc,
     DWORD *lpcItems )
{
     HANDLE hFile;
     TCHAR Buffer[MAX_DESC];
     TCHAR lpszFileName[sizeof( lpDesc[0]. lpszFileName )];
     TCHAR lpszDesc[sizeof( lpDesc[0]. lpszDesc )];

     *lpcItems = 0;
     hFile = CreateFile(
          lpcszFileName,
          GENERIC_READ,
          FILE_SHARE_READ,
          NULL,
          OPEN_EXISTING,
          FILE_ATTRIBUTE_NORMAL,
          NULL
     );
     if ( hFile != INVALID_HANDLE_VALUE )
     {
          for ( ; *lpcItems < dwDesc;  )
          {
               if ( !ReadLine( hFile, Buffer, sizeof( Buffer ) ) )
               {
                    break;
               }
               if ( !Buffer[0] )
               {
                    continue;
               }
               if ( !SplitFileDesc( Buffer, lpszFileName, lpszDesc ) )
               {
                    break;
               }
               strcpy( lpDesc[*lpcItems]. lpszFileName, lpszFileName );
               strcpy( lpDesc[*lpcItems]. lpszDesc, Buffer );
               ( *lpcItems )++;
          }
          CloseHandle( hFile );
     }

     return TRUE;
}

BOOL SaveDescFile(
     LPCTSTR lpcszFileName,
     DESC lpDesc[],
     DWORD dwDesc )
{
     BOOL bResult;
     HANDLE hFile;
     static TCHAR EOLn[] = { 0x0d, 0x0a };

     hFile = CreateFile(
          lpcszFileName,
          GENERIC_WRITE,
          FILE_SHARE_READ | FILE_SHARE_WRITE,
          NULL,
          CREATE_ALWAYS,
          FILE_ATTRIBUTE_NORMAL,
          NULL
     );

     bResult = hFile != INVALID_HANDLE_VALUE;

     if ( bResult )
     {
          for ( DWORD idx = 0, __dw; idx < dwDesc; idx++ )
          {
               if ( !lpDesc[idx]. lpszDesc[0] )
               {
                    continue;
               }
               if ( !WriteFile(
                         hFile,
                         lpDesc[idx]. lpszDesc,
                         strlen( lpDesc[idx]. lpszDesc ),
                         &__dw,
                         NULL ) )
               {
                    bResult = FALSE;
                    break;
               }
               if ( !WriteFile(
                         hFile,
                         EOLn,
                         sizeof( EOLn ),
                         &__dw,
                         NULL ) )
               {
                    bResult = FALSE;
                    break;
               }
          }
          CloseHandle( hFile );
     }

     return bResult;
}

BOOL FindDesc(
     LPCTSTR lpcszFileName,
     DESC lpDesc[],
     DWORD dwDesc,
     DWORD *lpdwFound )
{
     BOOL bResult = FALSE;

     for ( DWORD idx = 0; idx < dwDesc; idx++ )
     {
          if ( !stricmp( lpcszFileName, lpDesc[idx]. lpszFileName ) )
          {
               *lpdwFound = idx;
               bResult = TRUE;
               break;
          }
     }

     return bResult;
}

BOOL AddDesc(
     DESC lpDesc[],
     DWORD dwDesc,
     LPCTSTR lpcszFileName,
     LPCTSTR lpcszDesc,
     DWORD dwIndex )
{
     BOOL bResult = dwIndex < dwDesc;

     if ( bResult )
     {
          strcpy( lpDesc[dwIndex]. lpszFileName, lpcszFileName );
          strcpy( lpDesc[dwIndex]. lpszDesc, lpcszDesc );
     }

     return bResult;
}
