#include <windows.h>
#include <plugin.hpp>
#include <mp3tag.h>
#include <mp3tagz.h>
#include <mp3msg.h>
#include <mp3misc.h>
#include <mp3reg.h>
#include <mp3dlg.h>
#include <mp3tgfn.h>
#include <cvtfname.h>

BOOL UserDialog( tMP3TagToFromFilenameDlg *lpMP3Dlg, BOOL *lpToTag )
{
     int Button;

     Button = GetPSI() -> Dialog(
          GetPSI() -> ModuleNumber,
          -1, -1, 50, 7,
          MP3TAGFNAMEHELP,
          lpMP3Dlg -> Items(),
          lpMP3Dlg -> ItemsCount()
     );

     if ( ( Button == lpMP3Dlg -> Cancel() ) || ( Button == -1 ) )
     {
          return FALSE;
     }

     if ( !( lpMP3Dlg -> DataEntered() ) )
     {
          Message(
               FMSG_WARNING,
               GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MError ),
               GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MEmptyTempl )
          );
          return FALSE;
     }

     *lpToTag = Button == lpMP3Dlg -> Tag();

     return TRUE;
}

BOOL MP3TagToFromFilename(
     LPCTSTR MP3FileName,
     LPCTSTR Template,
     BOOL bToTag,
     BOOL *lpWrote )
{
     BOOL bResult = TRUE;
     BOOL Write = FALSE;
	tMP3tagZ tagZ;
     DWORD __dw;
     DWORD dwFlags = GetPluginFlags();
     TCHAR Buffer[sizeof( tagZ. findData. cFileName )];

     if ( !ValidMP3Ext( MP3FileName ) )
     {
          Message(
               FMSG_WARNING,
               MP3FileName,
               GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MNotMP3Ext )
          );
          bResult = FALSE;
     }

     if ( bResult )
     {
          bResult = ReadMP3TagZ( MP3FileName, &tagZ );
     }

     if ( bResult )
     {
          if ( bToTag )
          {
               if ( dwFlags & FL_UPDATE_TAG )
               {
                    ZeroTagZ( &tagZ );
                    tagZ. style = DEF_FNAME_TO_TAG_GENRE_CODE;
               }
               if( !tagZ. exist )
               {
                    tagZ. style = DEF_FNAME_TO_TAG_GENRE_CODE;
               }
               strcpy( Buffer, tagZ. findData. cFileName );
               for ( int idx = strlen( Buffer ) - 1; idx; idx-- )
               {
                    if ( Buffer[idx] == '.' )
                    {
                         Buffer[idx] = 0;
                         break;
                    }
               }
               __dw = FileNameToMP3TagZ( Buffer, Template, &tagZ );
               if ( ( __dw == EOF ) || ( __dw && !( dwFlags & FL_FULL_MATCH ) ) )
               {
                    Write = WriteMP3TagZ( &tagZ );
               }
          }
          else
          {
               bResult = MP3TagZToFileName(
                    Buffer,
                    Template,
                    &tagZ
               );
               if ( bResult )
               {
                    strcat( Buffer, Mp3Ext );
                    bResult = Write = MoveFile(
                         tagZ. findData. cFileName,
                         Buffer
                    );
               }
               if ( bResult )
               {
                    // update descriptions
                    // ...
               }
          }
     }

     if ( lpWrote != NULL )
     {
          *lpWrote = Write;
     }

     return bResult;
}

BOOL MP3TagToFromFilename( PanelInfo *lpPanelInfo, LPCTSTR Template, BOOL bToTag )
{
     BOOL bResult = TRUE;
     BOOL bWrote;

     for ( int idx = 0, stop = lpPanelInfo -> ItemsNumber; idx < stop; idx++ )
     {
          if ( !( lpPanelInfo -> PanelItems[idx]. Flags & PPIF_SELECTED ) )
          {
               continue;
          }
          if ( !MP3TagToFromFilename(
               lpPanelInfo -> PanelItems[idx]. FindData. cFileName,
               Template,
               bToTag,
               &bWrote ) )
          {
               bResult = FALSE;
               break;
          }
          if ( bWrote )
          {
               lpPanelInfo -> PanelItems[idx]. Flags &= ~PPIF_SELECTED;
          }
     }

     return bResult;
}

BOOL MP3TagToFromFilename()
{
     PanelInfo panelInfo;

     if ( !GetPSI() -> Control( INVALID_HANDLE_VALUE, FCTL_GETPANELINFO, &panelInfo ) )
     {
          return FALSE;
     }

     if ( panelInfo. PanelType != PTYPE_FILEPANEL )
     {
          return FALSE;
     }

     if ( !panelInfo. ItemsNumber )
     {
          return FALSE;
     }

     BOOL bResult;
     BOOL bToTag;
     tMP3TagToFromFilenameDlg MP3Dlg;

     if ( !UserDialog( &MP3Dlg, &bToTag ) )
     {
          return FALSE;
     }

     if ( PanelItemsSelected( &panelInfo ) )
     {
          bResult = MP3TagToFromFilename( &panelInfo, MP3Dlg. Template(), bToTag );
          GetPSI() -> Control( INVALID_HANDLE_VALUE, FCTL_SETSELECTION, &panelInfo );
          GetPSI() -> Control( INVALID_HANDLE_VALUE, FCTL_REDRAWPANEL, NULL );
     }
     else
     {
          bResult = MP3TagToFromFilename(
               panelInfo. PanelItems[panelInfo. CurrentItem]. FindData. cFileName,
               MP3Dlg. Template(),
               bToTag,
               NULL
          );
     }

     return bResult;
}

